import * as elements from "typed-html";

import { TimelineItem } from "../structs/timeline_item";



const TimelineCard = ({ date_start, date_end, title, description, icon_name}: TimelineItem) => {
    return (
        <div>
            <span class="absolute flex items-center justify-center w-6 h-6 bg-blue-100 rounded-full -start-3 ring-8 ring-white dark:ring-gray-900 dark:bg-blue-900">
            <svg class="w-2.5 h-2.5 text-blue-800 dark:text-blue-300" aria-hidden="true" xmlns="http://www.w3.org/2000/svg" fill="currentColor" viewBox="0 0 20 20">
                <path d="M20 4a2 2 0 0 0-2-2h-2V1a1 1 0 0 0-2 0v1h-3V1a1 1 0 0 0-2 0v1H6V1a1 1 0 0 0-2 0v1H2a2 2 0 0 0-2 2v2h20V4ZM0 18a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2V8H0v10Zm5-8h10a1 1 0 0 1 0 2H5a1 1 0 0 1 0-2Z"/>
            </svg>
            </span>
            <h3 class="mb-1 text-lg font-semibold text-gray-900">{ title }</h3>
            <time class="block mb-2 text-sm font-normal leading-none text-gray-400 dark:text-gray-500">{ date_start.toLocaleDateString() } - { date_end.toLocaleDateString() }</time>
            <p class="text-base font-normal text-gray-500 dark:text-gray-400">{ description }</p>
        </div>
    );
};

export { TimelineCard }