import { Elysia } from "elysia";
import { html } from "@elysiajs/html";
import { staticPlugin } from "@elysiajs/static";

import { BaseHTML } from "./base";
import { LandingPage } from "./pages/landing";

import { TimelineItem } from "./structs/timeline_item";
import { FooterLink } from "./structs/footer_link";

const timeline_items: TimelineItem[] = [
  {
    date_start: new Date(),
    date_end: new Date(),
    title: "First",
    description: "Description number 1",
    icon_name: "world",
  },
  {
    date_start: new Date(),
    date_end: new Date(),
    title: "Hello",
    description: "Description number 2",
    icon_name: "world",
  },
  {
    date_start: new Date(),
    date_end: new Date(),
    title: "Hello",
    description: "Longer description number 3",
    icon_name: "world",
  },
  {
    date_start: new Date(),
    date_end: new Date(),
    title: "Hello",
    description: "Very looooooooooong description number 4",
    icon_name: "world",
  },
  {
    date_start: new Date(),
    date_end: new Date(),
    title: "Hello",
    description: "Description number 5",
    icon_name: "world",
  },
  {
    date_start: new Date(),
    date_end: new Date(),
    title: "Hello",
    description: "Description number 6",
    icon_name: "world",
  },
  {
    date_start: new Date(),
    date_end: new Date(),
    title: "Hello",
    description: "Description number 7",
    icon_name: "world",
  },
  {
    date_start: new Date(),
    date_end: new Date(),
    title: "Hello",
    description: "Description number 8",
    icon_name: "world",
  },
];


const footer_links: FooterLink[] = [
  {
    icon_name: "github",
    title: "Github",
    url: "https://github.com",
  },
  {
    icon_name: "twitter",
    title: "Twitter",
    url: "https://twitter.com",
  },
  {
    icon_name: "linkedin",
    title: "LinkedIn",
    url: "https://linkedin.com",
  },
  {
    icon_name: "instagram",
    title: "Instagram",
    url: "https://instagram.com",
  },
  {
    icon_name: "facebook",
    title: "Facebook",
    url: "https://facebook.com",
  },
];

const content = {
  'timeline_items': timeline_items,
  'footer_links': footer_links,
};

export const server = new Elysia()
  .use(html())
  .use(staticPlugin())
  .onError(({ code, error }) => {
    console.error(code, error);
  })
  .get("/", ({html}) => html(<BaseHTML><LandingPage{content}/></BaseHTML>))
  .post("/clicked", ()=> <div>Hello?</div>)

  .listen(Bun.env["PORT"] ?? 3000);


console.log(
  `app is running at ${server.server?.hostname}:${server.server?.port}`,
);

export type ElysiaApp = typeof server;
